package org.expeditee.simple;

public class SReal extends SPrimitive<Double> {
	public static String prefix = SVariable.prefix + "r" + SVariable.separator;

	public SReal() {
		super();
	}

	public SReal(String name, Double value) {
		super(name, value);
	}

	public SReal(double value) throws Exception {
		super(value);
	}

	public SReal(float value) throws Exception {
		super((double) value);
	}

	@Override
	public void parse(String s) throws Exception {
		if (s == "")
			value_ = 0.0;
		else
			value_ = Double.parseDouble(s);
	}

	@Override
	public Boolean booleanValue() {
		return value_ > 0;
	}

	@Override
	public Long integerValue() {
		return value_.longValue();
	}

	@Override
	public Double doubleValue() {
		return value_;
	}

	@Override
	public Character characterValue() {
		return new Character((char) value_.intValue());
	}

	@Override
	public void setValue(SPrimitive v) throws IncorrectTypeException {
		value_ = v.doubleValue();
	}
}
